const std = @import("std");

const Task = @import("./Task.zig");

///
const Self = @This();

///
const TaskList = std.ArrayList(*Task);

///
alloc: std.mem.Allocator,

///
name: [:0]const u8,

///
tasks: TaskList,

///
pub fn init(alloc: std.mem.Allocator, name: []const u8) !Self {
    return Self {
        .alloc = alloc,
        .name  = try alloc.dupeZ(u8, name),
        .tasks = TaskList.init(alloc),
    };
}

///
pub fn deinit(self: *Self) void {
    self.tasks.deinit();
    self.alloc.free(self.name);
}

///
pub fn rename(self: *Self, name: []const u8) !void {
    self.alloc.free(self.name);
    self.name = try self.alloc.dupeZ(u8, name);
}

test {
    var stage = try init(std.testing.allocator, "helloworld");
    defer stage.deinit();
    try std.testing.expectEqualStrings("helloworld", stage.name);

    try stage.rename("goodbye");
    try std.testing.expectEqualStrings("goodbye", stage.name);
}
